<!-- HTML header for doxygen 1.8.8-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <!-- For Mobile Devices -->
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
        <meta name="generator" content="Doxygen 1.8.14"/>
        <script type="text/javascript" src="https://code.jquery.com/jquery-2.1.1.min.js"></script>
        <title>libinput: Device quirks</title>
        <!--<link href="tabs.css" rel="stylesheet" type="text/css"/>-->
        <script type="text/javascript" src="dynsections.js"></script>
        <script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" async src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
        <link href="doxygen.css" rel="stylesheet" type="text/css" />
        <link href="bootstrap.css" rel="stylesheet" type="text/css"/>
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
<link href="libinputdoxygen.css" rel="stylesheet" type="text/css"/>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.1/js/bootstrap.min.js"></script>
        <script type="text/javascript" src="doxy-boot.js"></script>
    </head>
    <body>
        <nav class="navbar navbar-default" role="navigation">
            <div class="container">
                <div class="navbar-header">
                    <a class="navbar-brand">libinput 1.11.900</a>
                </div>
            </div>
        </nav>
        <div id="top"><!-- do not remove this div, it is closed by doxygen! -->
            <div class="content" id="content">
                <div class="container">
                    <div class="row">
                        <div class="col-sm-12 panel panel-default" style="padding-bottom: 15px;">
                            <div style="margin-bottom: 15px;">
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="general.html">General</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Device quirks </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p><br />
</p>
<p>libinput requires extra information from devices that is not always readily available.</p>
<p>For example, some touchpads are known to have jumping cursors under specific conditions. libinput ships a set of files containting the so-called model quirks to provide that information. Model quirks are usually installed under <code>/usr/share/libinput/&lt;filename&gt;.quirks</code> and are standard <code>.ini</code> files. A file may contain multiple section headers (<code>[some identifier]</code>) followed by one or more <code>MatchFoo=Bar</code> directives, followed by at least one of <code>ModelFoo=1</code> or <code>AttrFoo=bar</code> directive. See the <code>data/README.md</code> file in the libinput source repository for more details on their contents.</p>
<dl class="section note"><dt>Note</dt><dd>Model quirks are internal API and may change at any time. No backwards-compatibility is guaranteed.</dd></dl>
<p>For example, a quirks file may have this content to label all keyboards on the serial bus (PS/2) as internal keyboards:</p>
<pre class="fragment">[Serial Keyboards]
MatchUdevType=keyboard
MatchBus=serial
AttrKeyboardIntegration=internal
</pre><p>The model quirks are part of the source distribution and should never be modified locally. Updates to libinput may overwrite modifications or even stop parsing any property. For temporary local workarounds, see <a class="el" href="device-quirks.html#device-quirks-local">Installing temporary local device quirks</a>.</p>
<p>Device quirks are parsed on libinput initialization. A parsing error in the device quirks disables <b>all</b> device quirks and may negatively impact device behavior on the host. If the quirks cannot be loaded, an error message is posted to the log and users should use the information in <a class="el" href="device-quirks.html#device-quirks-debugging">Debugging device quirks</a> to verify their quirks files.</p>
<h1><a class="anchor" id="device-quirks-local"></a>
Installing temporary local device quirks</h1>
<p>The model quirks are part of the source distribution and should never be modified. For temporary local workarounds, libinput reads the <code>/etc/libinput/local-overrides.quirks</code> file. Users may add a sections to this file to add a device quirk for a local device but beware that <b>any modification must be upstreamed</b> or it may cease to work at any time.</p>
<dl class="section note"><dt>Note</dt><dd>Model quirks are internal API and may change at any time. No backwards-compatibility is guaranteed. Local overrides should only be used until the distribution updates the libinput packages.</dd></dl>
<p>The <code>local-overrides.quirks</code> file usually needs to be created by the user. Once the required section has been added, use the information from section <a class="el" href="device-quirks.html#device-quirks-debugging">Debugging device quirks</a> to validate and test the quirks.</p>
<h1><a class="anchor" id="device-quirks-debugging"></a>
Debugging device quirks</h1>
<p>libinput provides the <code>libinput list-quirks</code> tool to list and debug model quirks that apply to one or more local devices.</p>
<pre class="fragment">$ libinput list-quirks /dev/input/event19
Device has no quirks defined
$ libinput list-quirks /dev/input/event0
AttrLidSwitchReliability
</pre><p>When called with the <code>--verbose</code> argument, <code>libinput list-quirks</code> prints information about all files and its attempts to match the device:</p>
<pre class="fragment">$ libinput list-quirks --verbose /dev/input/event0
quirks debug: /usr/share/share/libinput is data root
quirks debug: /usr/share/share/libinput/10-generic-keyboard.quirks
quirks debug: /usr/share/share/libinput/10-generic-lid.quirks
[...]
quirks debug: /usr/share/etc/libinput/local-overrides.quirks
quirks debug: /dev/input/event0: fetching quirks
quirks debug: [Serial Keyboards] (10-generic-keyboard.quirks) wants MatchBus but we don't have that
quirks debug: [Lid Switch Ct9] (10-generic-lid.quirks) matches for MatchName
quirks debug: [Lid Switch Ct10] (10-generic-lid.quirks) matches for MatchName
quirks debug: [Lid Switch Ct10] (10-generic-lid.quirks) matches for MatchDMIModalias
quirks debug: [Lid Switch Ct10] (10-generic-lid.quirks) is full match
quirks debug: property added: AttrLidSwitchReliability from [Lid Switch Ct10] (10-generic-lid.quirks)
quirks debug: [Aiptek No Tilt Tablet] (30-vendor-aiptek.quirks) wants MatchBus but we don't have that
[...]
quirks debug: [HUION PenTablet] (30-vendor-huion.quirks) wants MatchBus but we don't have that
quirks debug: [Logitech Marble Mouse Trackball] (30-vendor-logitech.quirks) wants MatchBus but we don't have that
quirks debug: [Logitech K400] (30-vendor-logitech.quirks) wants MatchBus but we don't have that
quirks debug: [Logitech K400r] (30-vendor-logitech.quirks) wants MatchBus but we don't have that
quirks debug: [Logitech K830] (30-vendor-logitech.quirks) wants MatchBus but we don't have that
quirks debug: [Logitech K400Plus] (30-vendor-logitech.quirks) wants MatchBus but we don't have that
quirks debug: [Logitech Wireless Touchpad] (30-vendor-logitech.quirks) wants MatchBus but we don't have that
quirks debug: [Microsoft Surface 3 Lid Switch] (30-vendor-microsoft.quirks) matches for MatchName
[...]
AttrLidSwitchReliability
</pre><p>Note that this is an example only, the output may change over time. The tool uses the same parser as libinput and any parsing errors will show up in the output. </p>
</div></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.8-->
<!-- start footer part -->
</div>
</div>
</div>
</div>
</div>
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.14
</small></address>
</body>
</html>
